//@todo: add door for exit
var maze = function()
{}
maze.prototype.width = 10;
maze.prototype.items = {};
maze.prototype.height = 10;
maze.prototype.maze = [];
maze.prototype.mazeMoves = [];
maze.prototype.startEd = {x:0,y:0};
maze.prototype.initMaze = function()
		{
			x = this.width;
			y = this.height;
			var n=x*y-1;
			if (n < 0) 
				{
						alert("illegal maze dimensions");return;
				}
			var horiz =[]; for (var j= 0; j<x+1; j++) horiz[j]= [],
			    verti =[]; for (var j= 0; j<y+1; j++) verti[j]= [],
			    here = [Math.floor(Math.random()*x), Math.floor(Math.random()*y)],
			    path = [here],
			    unvisited = [];

			for (var j = 0; j<x+2; j++) 
			{
				unvisited[j] = [];
				for (var k= 0; k<y+1; k++)
					unvisited[j].push(j>0 && j<x+1 && k>0 && (j != here[0]+1 || k != here[1]+1));
			}
			while (0<n) 
			{
				var potential = [[here[0]+1, here[1]], [here[0],here[1]+1],
				    [here[0]-1, here[1]], [here[0],here[1]-1]];
				var neighbors = [];
				
				for (var j = 0; j < 4; j++)
					if (unvisited[potential[j][0]+1][potential[j][1]+1])
						neighbors.push(potential[j]);

				if (neighbors.length) 
				{
					n = n-1;
					next= neighbors[Math.floor(Math.random()*neighbors.length)];
					unvisited[next[0]+1][next[1]+1]= false;
					if (next[0] == here[0])
					{
						horiz[next[0]][(next[1]+here[1]-1)/2]= true;
					}
					else
					{ 
						verti[(next[0]+here[0]-1)/2][next[1]]= true;
					}
					path.push(here = next);
				} 
				else
				{
					here = path.pop();
				}
			}
			return {x: x, y: y, horiz: horiz, verti: verti};
		};
maze.prototype.createMaze = function (x, y)
		{
			$('.game').css({width:62*x + 62, height: 62*x + 62});
			var maze =[]; for (var j= 0; j<x+1; j++) maze[j]= [];
			for (var i= 0; i<maze.length; i++)
				for (var j= 0; j<y+1; j++)
				{
					 if (i==0 || j == 0 || i==maze.length-1 || j==y || (i % 2 ==0 && j % 2 ==0))
					 {
						maze[i][j] = 1;	
					 }
					 else
					 {
						maze[i][j] = 0;	
					}

				}
		
	maze[0][1] = 0;		
	maze[maze.length-2][y] = 0;
	return maze;
};
maze.prototype.init = function()
{
	var maze = this.initMaze();
	var maze_array = this.createMaze(maze.x*2,maze.y*2);

	for (var i= 0; i< maze.horiz.length; i++)
	{
		for (var j= 0; j< maze.horiz[i].length; j++)
		{
			if (!maze.horiz[i][j])
			{
				maze_array[i*2+1][j*2+2] = 1;
			}		
		}		
		if(j>0)
		{
			for (var k =j; k < maze.y - 1; k++)
			{			
				maze_array[i*2+1][k*2+2] = 1;
			}
		}
		else
		{
			if (i < maze.x)
			{
				for (var k =j; k < maze.y - 1; k++)
				{			
					maze_array[i*2+1][k*2+2] = 1;
				}
			}		
		}
	}


	for (var i= 0; i< maze.verti.length; i++)
	{
		for (var j= 0; j< maze.verti[i].length; j++)
		{
			if (!maze.verti[i][j])
			{
				maze_array[i*2+2][j*2+1] = 1;
			}
		}
		if(j>0)
		{
			for (var k =j; k < maze.y; k++)
			{			
				maze_array[i*2+2][k*2+1] = 1;
			}
		}
		else
		{
			if (i < maze.x)
			{
				for (var k =j; k < maze.y; k++)
				{			
					maze_array[i*2+2][k*2+1] = 1;
				}
			}		
		}
	}

	this.maze = maze_array;
};
maze.prototype.renderTile= function(val, x, y, type)
{
	var $element = !type?'<div id="e-' + x + '-' + y + '" class="tile path"></div>' : type;
	if(!type)
	{
		if(val)
		{
			$element = '<div id ="e-' + x + '-' + y + '"" class="tile wall"></div>';
		}
	}
	
	return $element;
};
maze.prototype.putItem = function(x, y,elem, obj)
{
	if(!obj)
	{
		obj = false;
	}
	var tileID = [x,y];
		tileID = tileID.join('-');
	if(
			this.checkTile(x,y, false) 
		&&	this.items[tileID] == undefined
	)
	{
		$((['#e', x,y]).join('-')).html(elem);
		if(false != obj)
		this.items[tileID] = obj;

			return true;
	}
	return false;
};
maze.prototype.putItemOnRandomTile = function(elem, obj)
{
	var coordds = this.randomFreeTile();
	var success = this.putItem(coordds.x, coordds.y, elem, obj);
	if(false == success)
	{
		this.putItemOnRandomTile(elem, obj);
	}
};
maze.prototype.checkForItem = function(x,y) 
{
	tile = this.items[x + '-' + y];
	if(tile != undefined)
	{
		if (tile.onStep()){
			delete(this.items[x + '-' + y]);
		}
	}
};
maze.prototype.checkTile = function(x,y, checkAction)
{
	if(!checkAction)
	{
		checkAction = true;
	}
	var $return = false;
	if(this.maze[y][x] != undefined)
	{
			$return = this.maze[y][x] == 0;
			if(true == $return && checkAction)
			{
				this.checkForItem(x,y);
			}
	}
	return $return;
};
maze.prototype.randomFreeTile = function()
{
	var y = parseInt(Math.random()*this.maze.length);
	var x = parseInt(Math.random()*this.maze[0].length);
	if(!this.checkTile(x,y))
	{
		return this.randomFreeTile();
	}

	return {'x' : x, 'y' : y};
};
maze.prototype.renderMaze = function () 
{
	var m = this.maze;
		var output = '';
		
		for(y in m)
		{
			//output += m[k].join(' ') + '\r\n';
			for(x in m[y])
			{
				output += this.renderTile(m[y][x], x, y);
			}
			output += '<div class="clear"></div>';
		}
			
		return output;
};


var player = function(){};
player.prototype.currentPossition = {x:1, y:0};
player.prototype.htmlElement = "<div class=\"player\"></div>";
player.prototype.stash = {};
player.prototype.maze = {};
player.prototype.move = function (x,y)
{
	var $return = false;
	if(this.maze.checkTile(x,y))
	{
		this.currentPossition.x = x;
		this.currentPossition.y = y;
		$('.player').remove();
		this.maze.putItem(this.currentPossition.x, this.currentPossition.y, this.htmlElement);
		$return = true;
	}
	return $return;
	
};
player.prototype.UP = function()
{
	if(false == this.move(this.currentPossition.x, this.currentPossition.y +1))
	{

	}
}
player.prototype.DOWN = function()
{
	if(false == this.move(this.currentPossition.x, this.currentPossition.y -1))
	{
		
	}
}
player.prototype.LEFT = function()
{
	if(false == this.move(this.currentPossition.x +1, this.currentPossition.y))
	{
		
	}
}
player.prototype.RIGHT = function()
{
	if(false == this.move(this.currentPossition.x -1, this.currentPossition.y))
	{
		
	}
}
player.prototype.checkInStash = function(itemName)
{
	return this.stash[itemName] != undefined;
}
player.prototype.putInStash = function(itemName)
{
	this.stash[itemName] = true;
}
player.prototype.init = function()
{
	var instance = this;
  $(document).keydown(
	   function( e )
	   {
		switch(e.keyCode)
		{
		 case 39:
		 case 68:
		  instance.LEFT();
		  return false
		 break;
		 case 37:
		 case 65:
		  instance.RIGHT();
		  return false
		 break;
		 case 40:
		 case 83:
		  instance.UP();
		  return false
		 break;
		 case 38:
		 case 87:
		  instance.DOWN();
		  return false
		 break;
		}
	   }
	  );
		//@TODO: render player		
		this.maze.putItem(this.currentPossition.x, this.currentPossition.y, this.htmlElement);
		
};


var item = function(){};
item.prototype.type = '';
item.prototype.player = {};
item.prototype.render = function(){};
item.prototype.onStep = function(){};

var game = function(){};
game.prototype.maze = {};
game.prototype.player= {};
game.prototype.initItems = function()
{
	var items = {
		banana : 
		{
			'htmlElement' :  "<div class=\"e_banana\"></div>",
			'onStep' : function()
			{
				$('.e_banana').remove();
				$('#banana').removeClass('banana_off');
				$('#banana').addClass('banana_on');
				//this.player.putInStash('banana');
			
				return true;
			},
		},
		money : 
		{
			'htmlElement' :  "<div class=\"e_money\"></div>",
			'onStep' : function(){$('.e_money').remove();  
				$('#money').removeClass('money_off');
				$('#money').addClass('money_on');
			return true;},
		},
		potion : 
		{
			'htmlElement' :  "<div class=\"e_potion\"></div>",
			'onStep' : function(){$('.e_potion').remove();
				$('#potion').removeClass('potion_off');
				$('#potion').addClass('potion_on');
			return true;},
		},
		key : 
		{
			'htmlElement' :  "<div class=\"e_key\"></div>",
			'onStep' : function(){$('.e_key').remove();
				$('#key').removeClass('key_off');
				$('#key').addClass('key_on');
			return true;},
		},
		bandit : 
		{
			'htmlElement' :  "<div class=\"e_bandit\"></div>",
			'onStep' : function(){
			/*
				if (this.player.checkInStash('money')){	
					$('.e_bandit').remove();				
					return true;
				}			
				*/
			},
		},
		frog : 
		{
			'htmlElement' :  "<div class=\"e_frog\"></div>",
			'onStep' : function(){
				$('#healthimage').removeClass('healthy');
				$('#healthimage').addClass('posion');
			
			},
		},
		monkey : 
		{
			'htmlElement' :  "<div class=\"e_monkey\"></div>",
			'onStep' : function(){
			/*
				if (this.player.checkInStash('banana')){	
					$('.e_monkey').remove();				
					return true;
				}	
			*/	
			
			},
		}
	};
	for (itemName in items) 
	{
		var Item = new item();
		Item.player = this.player;
		Item.type = itemName;
		Item.onStep = items[itemName].onStep;
		this.maze.putItemOnRandomTile(items[itemName].htmlElement, Item);
	}
};
game.prototype.initialize = function()
{
	this.maze = new maze();
	this.maze.init();
	$('.game').html(Game.maze.renderMaze());	
	this.initItems();
	this.player = new player();
	this.player.maze = this.maze;
	this.player.init();
	
	var door = new item();
	 door.type = 'door';
	 door.onStep = function(){};
	 this.maze.putItem(this.maze.maze.length-1,this.maze.maze.length-2,'<div class=\"e_door\"></div>', door);
	
	

};

var Game = new game();
$(function()
{	
	Game.initialize();		
	$('#header').css({'width': $('.game').width()});
	
});