
KEY = 1;
MAXKEY = 2;


function player_animation(){
	KEY++;	
	if (KEY > MAXKEY){
		KEY = 1;
	}
	var position = -(KEY-1)*62;
	$("#player").css({				
		'background-position': position
	});	
}

function maze(x,y) {
	var n=x*y-1;
	if (n<0) {alert("illegal maze dimensions");return;}
	var horiz =[]; for (var j= 0; j<x+1; j++) horiz[j]= [],
	    verti =[]; for (var j= 0; j<y+1; j++) verti[j]= [],
	    here = [Math.floor(Math.random()*x), Math.floor(Math.random()*y)],
	    path = [here],
	    unvisited = [];
	for (var j = 0; j<x+2; j++) {
		unvisited[j] = [];
		for (var k= 0; k<y+1; k++)
			unvisited[j].push(j>0 && j<x+1 && k>0 && (j != here[0]+1 || k != here[1]+1));
	}
	while (0<n) {
		var potential = [[here[0]+1, here[1]], [here[0],here[1]+1],
		    [here[0]-1, here[1]], [here[0],here[1]-1]];
		var neighbors = [];
		for (var j = 0; j < 4; j++)
			if (unvisited[potential[j][0]+1][potential[j][1]+1])
				neighbors.push(potential[j]);
		if (neighbors.length) {
			n = n-1;
			next= neighbors[Math.floor(Math.random()*neighbors.length)];
			unvisited[next[0]+1][next[1]+1]= false;
			if (next[0] == here[0])
				horiz[next[0]][(next[1]+here[1]-1)/2]= true;
			else 
				verti[(next[0]+here[0]-1)/2][next[1]]= true;
			path.push(here = next);
		} else 
			here = path.pop();
	}
	return {x: x, y: y, horiz: horiz, verti: verti};
}
function display(m) {
	var text= [];
	for (var j= 0; j<m.x*2+1; j++) {
		var line= [];
		if (0 == j%2)
			for (var k=0; k<m.y*4+1; k++)
				if (0 == k%4) 
					line[k]= '+';
				else
					if (j>0 && m.verti[j/2-1][Math.floor(k/4)])
						line[k]= ' ';
					else
						line[k]= '-';
		else
			for (var k=0; k<m.y*4+1; k++)
				if (0 == k%4)
					if (k>0 && m.horiz[(j-1)/2][k/4-1])
						line[k]= ' ';
					else
						line[k]= '|';
				else
					line[k]= ' ';
		if (0 == j) line[1]= line[2]= line[3]= ' ';
		if (m.x*2-1 == j) line[4*m.y]= ' ';
		text.push(line.join('')+'\r\n');
	}
	return text.join('');
}

function create_maze_array(x,y) {
	var maze =[]; for (var j= 0; j<x+1; j++) maze[j]= [];
	for (var i= 0; i<maze.length; i++)
		for (var j= 0; j<y+1; j++){
			 if (i==0 || j == 0 || i==maze.length-1 || j==y || (i % 2 ==0 && j % 2 ==0)){
				maze[i][j] = 1;	
			 }else{
				maze[i][j] = 0;	
			}

		}
		
	maze[0][1] = 0;		
	maze[maze.length-2][y] = 0;
	return maze;
}

function display_array(m) {
	var output = '';
	for (var i= 0; i< m.length; i++){		
		for (var j= 0; j< m[i].length; j++){
			output +=  ' ' + m[i][j];
		}
		output += '\r\n';
	}
		
	return output;
}

function display_screen(m) {
	var output = '';
	for (var i= 0; i< m.length; i++){		
		for (var j= 0; j< m[i].length; j++){
			el_class = 'empty';
			if (m[i][j]){
				el_class = 'brick';
			}
			output +=  '<div class="' + el_class + '" > </div>';
		}		
	}
		
	return output;
}

//tuk
var maze = maze(5,10);
var maze_array = create_maze_array(maze.x*2,maze.y*2);

for (var i= 0; i< maze.horiz.length; i++){
	for (var j= 0; j< maze.horiz[i].length; j++){
		if (!maze.horiz[i][j]){
			maze_array[i*2+1][j*2+2] = 1;
		}		
	}		
	if(j>0){
		for (var k =j; k < maze.y - 1; k++){			
			maze_array[i*2+1][k*2+2] = 1;
		}
	}else{
		if (i < maze.x){
			for (var k =j; k < maze.y - 1; k++){			
				maze_array[i*2+1][k*2+2] = 1;
			}
		}		
	}
}


for (var i= 0; i< maze.verti.length; i++){
	for (var j= 0; j< maze.verti[i].length; j++){
		if (!maze.verti[i][j]){
			maze_array[i*2+2][j*2+1] = 1;
		}
	}
	//alert( maze.verti[i].length);
	if(j>0){
		for (var k =j; k < maze.y; k++){			
			maze_array[i*2+2][k*2+1] = 1;
		}
	}else{
		if (i < maze.x){
			for (var k =j; k < maze.y; k++){			
				maze_array[i*2+2][k*2+1] = 1;
			}
		}		
	}
}









/////////////////////////////////////////////////////////
var HISTORY = [];
var DIRECTIONS = ['up','down','left','right'];
var PLAYER_X = 1;
var PLAYER_Y = 0;
var HISTORY_X = 0;
var HISTORY_Y = 0;

function player_move(){
	new_direction = DIRECTIONS[Math.floor((Math.random() * 4))];	
	var _x = PLAYER_X;
	var _y = PLAYER_Y;
	if (new_direction == 'up'){
		_y = PLAYER_Y - 1;
	}
	if (new_direction == 'down'){
		_y = PLAYER_Y + 1;
	}
	if (new_direction == 'left'){
		_x = PLAYER_X - 1;
	}
	if (new_direction == 'right'){
		_x = PLAYER_X + 1;
	}
	
	if (_x < 0 || _y < 0){		
		return;
	}
	if (maze_array[_y][_x]){		
		return;
	}
	if (_x == HISTORY_X && _y == HISTORY_Y){
		if (maze_array[PLAYER_Y-1][PLAYER_X] + maze_array[PLAYER_Y+1][PLAYER_X]  + maze_array[PLAYER_Y][PLAYER_X-1]  + maze_array[PLAYER_Y][PLAYER_X+1] != 3){				
			return
		}
	}
	
	HISTORY_X = PLAYER_X;
	HISTORY_Y = PLAYER_Y;
	
	PLAYER_X = _x;
	PLAYER_Y = _y;
	
	$('#player').css({'margin-left': ((PLAYER_X)*62 ) + 'px','margin-top': ((PLAYER_Y)*62 ) + 'px'});
		
}


$(function() {	
	document.getElementById('screen').style.width = maze_array[0].length * 62;
	document.getElementById('screen').style.height = maze_array.length * 62;
	document.getElementById('screen').innerHTML= display_screen(maze_array) + '<div id="player"></div><div id="door"></div>'; 

	$('#door').css({'margin-left': ((maze_array[0].length-1)*62 ) + 'px','margin-top': ((maze_array.length-2)*62 ) + 'px'});
	setInterval('player_animation()',700);
	setInterval('player_move()',100);
	
	
	
});	
	